#! /usr/bin/env python
#
# Example program using irc.client.
#
# This program is free without restrictions; do anything you like with
# it.
#
# Joel Rosdahl <joel@rosdahl.net>

from time import sleep
from random import randint
import irc.client
import sys
import subprocess

class PwnBot(irc.client.SimpleIRCClient):
    def __init__(self, botName, flag):
        irc.client.SimpleIRCClient.__init__(self)
        self.botName= botName
        self.flag = flag

    def on_welcome(self, connection, event):
        print(connection.nickname + " was welcomed")
        print("Sending 'Hello' to Bot")
        connection.privmsg(self.botName, "Hello")

    def on_join(self, connection, event):
        print(connection.nickname + " joined " + str(event.target))

    def on_disconnect(self, connection, event):
        sys.exit(1)

    def launchSlaves(self, channel):
       rname ="Romeo"+str(randint(1000,9999))
       args= ["python", "luvbot.py", self.connection.server+ ":" + str(self.connection.port), rname, channel, "romeo.txt"]
       subprocess.Popen(args)
       
       jname ="Juliet"+str(randint(1000,9999))
       args = ["python", "luvbot.py", self.connection.server +":" + str(self.connection.port), jname, channel, "juliet.txt"]
       subprocess.Popen(args)

       sleep(10)

       self.connection.privmsg(rname, "add friend")
       self.connection.privmsg(rname, "pwn")

    def on_privmsg(self, connection, event):
        print(connection.nickname + " recv " + str(event.arguments))
        if event.arguments[0] == "done" and "Romeo" in event.source:
           self.connection.privmsg(self.botName, "done")

    def on_privnotice(self, connection, event):
        print(connection.nickname + " recv note " + str(event.arguments) + " from " + event.source)
        if "You must!" in event.arguments[0] and self.botName in event.source :
           print("Sending Auth Strint to Bot")
           connection.privmsg(self.botName, "Who calls me?")
        elif "Find me at" in event.arguments[0] and self.botName in event.source :
           print("Extracting channel")
           offset = len("Find me at ")
           channel = event.arguments[0][offset:offset+17]
           print("Launching Bots to "+ channel)
           self.launchSlaves(channel)
        elif "I will meet you at" in event.arguments[0] and self.botName in event.source :
           print("Extracting channel")
           offset = len("I will meet you at ")
           channel = event.arguments[0][offset:offset+17]
           print("Launching Bots to "+ channel)
           self.launchSlaves(channel)
        elif "declaim" in event.arguments[0] and self.botName in event.source :
           print("Reconnection to last Session")
           connection.privmsg(self.botName, "help")
        elif "hackover2016" in event.arguments[0]:
           if self.flag in event.arguments[0]:
              print("Flag is online")
              connection.privmsg(self.botName, "forget")
              sys.exit(0)


 
def makeMaster(server, port, nick, flag):
    c = PwnBot("shakedbot", flag)
    try:
        c.connect(server, port, nick)
    except irc.client.ServerConnectionError as x:
        print(x)
        return 
    return c

def main():
    if len(sys.argv) != 4:
        print("Usage: pwnBot <server[:port]> <nickname> <flag>")
        print("\ntarget is a nickname or a channel.")
        sys.exit(1)

    s = sys.argv[1].split(":", 1)
    server = s[0]
    if len(s) == 2:
        try:
            port = int(s[1])
        except ValueError:
            print("Error: Erroneous port.")
            sys.exit(1)
    else:
        port = 6667
    nickname = sys.argv[2]
    flag = sys.argv[3]
    makeMaster(server, port, nickname, flag).start()

if __name__ == "__main__":
    main()
